//dehyphenate: remove '-' from the ends of lines, thus merging back divided words
//Fri Mar 17 14:31:32 EST 2006 Peter A. Cejchan <cej@gli.cas.cz | pac7@post.cz | pac@plan9.cz>
//"With A Little Help Of My Friends"... actually, most of the code is reused from strings.c ... thanks!

#include	<u.h>
#include 	<libc.h>
#include	<bio.h>

Biobuf	*fin;
Biobuf	fout;

#define	MINSPAN		1		/* Min characters in string */

#define BUFSIZE		70

void stringit(char *);
int isprint(Rune);

void
main(int argc, char **argv)
{
	int i;

	Binit(&fout, 1, OWRITE);
	if(argc < 2) {
		stringit("/fd/0");
		exits(0);
	}

	for(i = 1; i < argc; i++) {
		if(argc > 2)
			print("%s:\n", argv[i]);

		stringit(argv[i]);
	}

	exits(0);
}

void
stringit(char *str)
{
	long posn, start;
	int cnt = 0,  print=1;
	long b,c;

	Rune buf[BUFSIZE];

	if ((fin = Bopen(str, OREAD)) == 0) {
		perror("open");
		return;
	}

	start = 0;
	posn = Boffset(fin);
	b=' ';
	while((c = Bgetrune(fin)) >= 0) {
		if(b == '-'){
//			if(start == 0)
//				start = posn;


			if(c==0x0a){
// delete newline and '-'
				cnt--; print=0;
			} else{
			}
		}
		if (print) buf[cnt++] = c;
		print=1;
			if(cnt == BUFSIZE-1) {
				buf[cnt] = 0;
				Bprint(&fout, "%S", buf);
				start = 0;
				cnt = 0;
			}
/*
		else {
			 if(cnt >= MINSPAN) {
				buf[cnt] = 0;
				Bprint(&fout, "%S", buf);
			}
			start = 0;
			cnt = 0;
		}
*/

		b=c;
		posn = Boffset(fin);
	}

 	if(cnt >= MINSPAN){
		buf[cnt] = 0;
		Bprint(&fout, "%S", buf);
	}
	Bterm(fin);
}

int
isprint(Rune r)
{
	if ((r >= ' ' && r <0x7f) || r > 0xA0 || r == 0x0a)
		return 1;
	else
		return 0;
}
